clc;
clear;
close all
tic;

cd('C:\Users\James\Desktop\Older Work\Finished Papers\Forthcoming\Revealed preference tests of the Cournot model\Tables\CDFQ_ECMA_Files')
load('oildata.mat')

%Replace zero production with 1, so quadprog can handle it
[a,b]=size(opecquantities);
for i=1:a
    for j=1:b
        zerosmatrix(i,j)=(opecquantities(i,j)==0);
    end
end
augmentedopecquantities=zerosmatrix+opecquantities;

%%%Table 1A: Convex Costs: Rejection Rates with OPEC Countries
windows=[3;6;12]; %All tests use 3, 6, and 12 month windows
table=1;
panel=1;

%First Column: Combos of 2 countries
column=1;
pricevector=oilpricereal2009;
quantmatrix=augmentedopecquantities;
ncountries=2;

Ncountries=size(quantmatrix,2); 
rejectionrate=0;
output=[0,0,0];
for w=1:length(windows);
    window=windows(w);
    ntests = (436+1-window)*nchoosek(Ncountries,ncountries);
    rejections = [];
        if rejectionrate>=0.99
        rejectionrate=1;
        end  
    if rejectionrate<0.99
    for i1=1 : Ncountries-1
        for i2=i1+1:Ncountries  
         qinterest=[quantmatrix(:,i1),quantmatrix(:,i2)];
         nmonths=size(qinterest,1);
         nperiods=nmonths-window;
             for y=1 : nperiods
                 m0=y;
                 mEnd=m0+window-1;     
                 testconvex(pricevector(m0:mEnd,:),qinterest(m0:mEnd,:));
                 rejections=[rejections;ans.reject];
                 progress=[table,panel,column,window,100*length(rejections)/ntests]
             end
        end
    end
    rejectionrate=mean(rejections);
    end
    output=[output;ncountries,window,rejectionrate];
end
    save convex_opec_2countries output
    
%Second Column: Combos of 3 Countries
column=column+1;
pricevector=oilpricereal2009;
quantmatrix=augmentedopecquantities;
ncountries=3;

Ncountries=size(quantmatrix,2);
rejectionrate=0;
output=[0,0,0];
for w=1:length(windows);
    window=windows(w);
    ntests = (436+1-window)*nchoosek(Ncountries,ncountries);
    rejections = [];
        if rejectionrate>=0.99
        rejectionrate=1;
        end  
    if rejectionrate<0.99
    for i1=1 : Ncountries-2
        for i2=i1+1:Ncountries-1
        for i3=i2+1:Ncountries 
         qinterest=[quantmatrix(:,i1),quantmatrix(:,i2),quantmatrix(:,i3)];
         nmonths=size(qinterest,1);
         nperiods=nmonths-window;
             for y=1 : nperiods
                 m0=y;
                 mEnd=m0+window-1;     
                 testconvex(pricevector(m0:mEnd,:),qinterest(m0:mEnd,:));
                 rejections=[rejections;ans.reject];
                 progress=[table,panel,column,window,100*length(rejections)/ntests]
             end
        end
        end
    end
    rejectionrate=mean(rejections);
    end
    output=[output;ncountries,window,rejectionrate];
end
        save convex_opec_3countries output
    
%Third Column: Combos of 6 Countries
column=column+1;
pricevector=oilpricereal2009;
quantmatrix=augmentedopecquantities;
ncountries=6;

Ncountries=size(quantmatrix,2);
rejectionrate=0;
output=[0,0,0];
for w=1:length(windows);
    window=windows(w);
    ntests = (436+1-window)*nchoosek(Ncountries,ncountries);
    rejections = [];
        if rejectionrate>=0.99
        rejectionrate=1;
        end  
    if rejectionrate<0.99
    for i1=1 : Ncountries-5
        for i2=i1+1:Ncountries-4
        for i3=i2+1:Ncountries-3 
        for i4=i3+1:Ncountries-2
        for i5=i4+1:Ncountries-1
        for i6=i5+1:Ncountries 
         qinterest=[quantmatrix(:,i1),quantmatrix(:,i2),quantmatrix(:,i3),quantmatrix(:,i4),quantmatrix(:,i5),quantmatrix(:,i6)];
         nmonths=size(qinterest,1);
         nperiods=nmonths-window;
             for y=1 : nperiods
                 m0=y;
                 mEnd=m0+window-1;     
                 testconvex(pricevector(m0:mEnd,:),qinterest(m0:mEnd,:));
                 rejections=[rejections;ans.reject];
                 progress=[table,panel,column,window,100*length(rejections)/ntests]
             end
        end
        end
        end
        end
        end
    end
    rejectionrate=mean(rejections);
    end
    output=[output;ncountries,window,rejectionrate];
end
       save convex_opec_6countries output  
               
%Fourth Column: Combos of 12 Countries (i.e. Everybody)
column=column+1;
pricevector=oilpricereal2009;
quantmatrix=augmentedopecquantities;
ncountries=12;

Ncountries=size(quantmatrix,2);
rejectionrate=0;
output=[0,0,0];
for w=1:length(windows);
    window=windows(w);
    ntests = (436+1-window)*nchoosek(Ncountries,ncountries);
    rejections = [];
        if rejectionrate>=0.99
        rejectionrate=1;
        end  
    if rejectionrate<0.99
         qinterest=quantmatrix;
         nmonths=size(qinterest,1);
         nperiods=nmonths-window;
             for y=1 : nperiods
                 m0=y;
                 mEnd=m0+window-1;     
                 testconvex(pricevector(m0:mEnd,:),qinterest(m0:mEnd,:));
                 rejections=[rejections;ans.reject];
                 progress=[table,panel,column,window,100*length(rejections)/ntests]
             end    
    rejectionrate=mean(rejections);
end
    output=[output;ncountries,window,rejectionrate];
end
        save convex_opec_12countries output

%%%Table 1B: Convex Costs: Rejection Rates with non-OPEC Countries 
%First Column: Combos of 2 Countries
column=1;
table=1;
panel=2;
pricevector=oilpricereal2009;
quantmatrix=nonopecquantities;
ncountries=2;

Ncountries=size(quantmatrix,2); 
rejectionrate=0;
output=[0,0,0];
for w=1:length(windows);
    window=windows(w);
    ntests = (436+1-window)*nchoosek(Ncountries,ncountries);
    rejections = [];
        if rejectionrate>=0.99
        rejectionrate=1;
        end  
    if rejectionrate<0.99
    for i1=1 : Ncountries-1
        for i2=i1+1:Ncountries  
         qinterest=[quantmatrix(:,i1),quantmatrix(:,i2)];
         nmonths=size(qinterest,1);
         nperiods=nmonths-window;
             for y=1 : nperiods
                 m0=y;
                 mEnd=m0+window-1;     
                 testconvex(pricevector(m0:mEnd,:),qinterest(m0:mEnd,:));
                 rejections=[rejections;ans.reject];
                 progress=[table,panel,column,window,100*length(rejections)/ntests]
             end
        end
    end
    rejectionrate=mean(rejections);
    end
    output=[output;ncountries,window,rejectionrate];
end
    save convex_nonopec_2countries output
    
%Second Column: Combos of 3 Countries
column=column+1;
pricevector=oilpricereal2009;
quantmatrix=nonopecquantities;
ncountries=3;

Ncountries=size(quantmatrix,2); 
rejectionrate=0;
output=[0,0,0];
for w=1:length(windows);
    window=windows(w);
    ntests = (436+1-window)*nchoosek(Ncountries,ncountries);
    rejections = [];
        if rejectionrate>=0.99
        rejectionrate=1;
        end  
    if rejectionrate<0.99
    for i1=1 : Ncountries-2
        for i2=i1+1:Ncountries-1
        for i3=i2+1:Ncountries 
         qinterest=[quantmatrix(:,i1),quantmatrix(:,i2),quantmatrix(:,i3)];
         nmonths=size(qinterest,1);
         nperiods=nmonths-window;
             for y=1 : nperiods
                 m0=y;
                 mEnd=m0+window-1;     
                 testconvex(pricevector(m0:mEnd,:),qinterest(m0:mEnd,:));
                 rejections=[rejections;ans.reject];
                 progress=[table,panel,column,window,100*length(rejections)/ntests]
             end
        end
        end
    end
    rejectionrate=mean(rejections);
    end
    output=[output;ncountries,window,rejectionrate];
end
    save convex_nonopec_3countries output
    
%Third Column: Combos of 6 Countries
column=column+1;
pricevector=oilpricereal2009;
quantmatrix=nonopecquantities;
ncountries=6;

Ncountries=size(quantmatrix,2); 
rejectionrate=0;
output=[0,0,0];
for w=1:length(windows);
    window=windows(w);
    ntests = (436+1-window)*nchoosek(Ncountries,ncountries);
    rejections = [];
        if rejectionrate>=0.99
        rejectionrate=1;
        end  
    if rejectionrate<0.99
    for i1=1 : Ncountries-5
        for i2=i1+1:Ncountries-4
        for i3=i2+1:Ncountries-3 
        for i4=i3+1:Ncountries-2
        for i5=i4+1:Ncountries-1
        for i6=i5+1:Ncountries 
         qinterest=[quantmatrix(:,i1),quantmatrix(:,i2),quantmatrix(:,i3),quantmatrix(:,i4),quantmatrix(:,i5),quantmatrix(:,i6)];
         nmonths=size(qinterest,1);
         nperiods=nmonths-window;
             for y=1 : nperiods
                 m0=y;
                 mEnd=m0+window-1;     
                 testconvex(pricevector(m0:mEnd,:),qinterest(m0:mEnd,:));
                 rejections=[rejections;ans.reject];
                 progress=[table,panel,column,window,100*length(rejections)/ntests]
             end
        end
        end
        end
        end
        end
    end
    rejectionrate=mean(rejections);
    end
    output=[output;ncountries,window,rejectionrate];
end
    save convex_nonopec_6countries output  
               
%Fourth Column: Combos of 7 Countries (i.e. Everybody)
column=4;
pricevector=oilpricereal2009;
quantmatrix=nonopecquantities;
ncountries=7;

Ncountries=size(quantmatrix,2); 
rejectionrate=0;
output=[0,0,0];
for w=1:length(windows);
    window=windows(w);
    ntests = (436+1-window)*nchoosek(Ncountries,ncountries);
    rejections = [];
        if rejectionrate>=0.99
        rejectionrate=1;
        end  
    if rejectionrate<0.99
         qinterest=quantmatrix;
         nmonths=size(qinterest,1);
         nperiods=nmonths-window;
             for y=1 : nperiods
                 m0=y;
                 mEnd=m0+window-1;     
                 testconvex(pricevector(m0:mEnd,:),qinterest(m0:mEnd,:));
                 rejections=[rejections;ans.reject];
                 progress=[table,panel,column,window,100*length(rejections)/ntests]
             end    
    rejectionrate=mean(rejections);
    end
    output=[output;ncountries,window,rejectionrate];
end
    save convex_nonopec_12countries output
    